/*++
## Project ##
Universal Windows Extender
DIRECTX

## Thanks ##
WINE

## Module ##
MFPLAT

## File ##
compat\UUPLAT\main.cpp

## Author ##
    GlitchR9506
Revision  Revision  Flags:        Details:
ID:       Date:
--------  --------  ------------  ----------------------------------------------------
--*/
#define CINTERFACE
#define COBJMACROS
#include "forwards.h"
#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdarg.h>
#include <winternl.h>
#include <unknwn.h>
#include <initguid.h>

typedef int WINBOOL,*PWINBOOL,*LPWINBOOL;
BOOL WINAPI DllMain(
    HINSTANCE hinstDLL,  // handle to DLL module
    DWORD fdwReason,     // reason for calling function
    LPVOID lpvReserved )  // reserved
{
    // Perform actions based on the reason for calling.
    switch( fdwReason ) 
    { 
        case DLL_PROCESS_ATTACH:
         // Initialize once for each new process.
         // Return FALSE to fail DLL load.
            break;

        case DLL_THREAD_ATTACH:
         // Do thread-specific initialization.
            break;

        case DLL_THREAD_DETACH:
         // Do thread-specific cleanup.
            break;

        case DLL_PROCESS_DETACH:
        
            if (lpvReserved != NULL)
            {
                break; // do not do cleanup if process termination scenario
            }
            
         // Perform any necessary cleanup.
            break;
    }
    return TRUE;  // Successful DLL_PROCESS_ATTACH.
}

/***********************************************************************
 *      MFCreateDXGIDeviceManager (mfplat.@)
 */
 
#ifndef __IMFDXGIDeviceManager_FWD_DEFINED__
#define __IMFDXGIDeviceManager_FWD_DEFINED__
typedef interface IMFDXGIDeviceManager IMFDXGIDeviceManager;
#endif
/*****************************************************************************
 * IMFDXGIDeviceManager interface
 */
#ifndef __IMFDXGIDeviceManager_INTERFACE_DEFINED__
#define __IMFDXGIDeviceManager_INTERFACE_DEFINED__

DEFINE_GUID(IID_IMFDXGIDeviceManager, 0xeb533d5d, 0x2db6, 0x40f8, 0x97,0xa9, 0x49,0x46,0x92,0x01,0x4f,0x07);
DEFINE_GUID(IID_ID3D11Device, 0xdb6f6ddb, 0xac77, 0x4e88, 0x82, 0x53, 0x81, 0x9d, 0xf9, 0xbb, 0xf1, 0x40 );
DEFINE_GUID(IID_ID3D12Device,0x189819f1,0x1db6,0x4b57,0xbe,0x54,0x18,0x21,0x33,0x9b,0x85,0xf7);

#if defined(__cplusplus) && !defined(CINTERFACE)
MIDL_INTERFACE("eb533d5d-2db6-40f8-97a9-494692014f07")
IMFDXGIDeviceManager : public IUnknown
{
    virtual HRESULT STDMETHODCALLTYPE CloseDeviceHandle(
        HANDLE hDevice) = 0;

    virtual HRESULT STDMETHODCALLTYPE GetVideoService(
        HANDLE hDevice,
        REFIID riid,
        void **ppService) = 0;

    virtual HRESULT STDMETHODCALLTYPE LockDevice(
        HANDLE hDevice,
        REFIID riid,
        void **ppUnkDevice,
        WINBOOL fBlock) = 0;

    virtual HRESULT STDMETHODCALLTYPE OpenDeviceHandle(
        HANDLE *phDevice) = 0;

    virtual HRESULT STDMETHODCALLTYPE ResetDevice(
        IUnknown *pUnkDevice,
        UINT resetToken) = 0;

    virtual HRESULT STDMETHODCALLTYPE TestDevice(
        HANDLE hDevice) = 0;

    virtual HRESULT STDMETHODCALLTYPE UnlockDevice(
        HANDLE hDevice,
        WINBOOL fSaveState) = 0;

};
#ifdef __CRT_UUID_DECL
__CRT_UUID_DECL(IMFDXGIDeviceManager, 0xeb533d5d, 0x2db6, 0x40f8, 0x97,0xa9, 0x49,0x46,0x92,0x01,0x4f,0x07)
#endif
#else
typedef struct IMFDXGIDeviceManagerVtbl {
    BEGIN_INTERFACE

    /*** IUnknown methods ***/
    HRESULT (STDMETHODCALLTYPE *QueryInterface)(
        IMFDXGIDeviceManager* This,
        REFIID riid,
        void **ppvObject);

    ULONG (STDMETHODCALLTYPE *AddRef)(
        IMFDXGIDeviceManager* This);

    ULONG (STDMETHODCALLTYPE *Release)(
        IMFDXGIDeviceManager* This);

    /*** IMFDXGIDeviceManager methods ***/
    HRESULT (STDMETHODCALLTYPE *CloseDeviceHandle)(
        IMFDXGIDeviceManager* This,
        HANDLE hDevice);

    HRESULT (STDMETHODCALLTYPE *GetVideoService)(
        IMFDXGIDeviceManager* This,
        HANDLE hDevice,
        REFIID riid,
        void **ppService);

    HRESULT (STDMETHODCALLTYPE *LockDevice)(
        IMFDXGIDeviceManager* This,
        HANDLE hDevice,
        REFIID riid,
        void **ppUnkDevice,
        WINBOOL fBlock);

    HRESULT (STDMETHODCALLTYPE *OpenDeviceHandle)(
        IMFDXGIDeviceManager* This,
        HANDLE *phDevice);

    HRESULT (STDMETHODCALLTYPE *ResetDevice)(
        IMFDXGIDeviceManager* This,
        IUnknown *pUnkDevice,
        UINT resetToken);

    HRESULT (STDMETHODCALLTYPE *TestDevice)(
        IMFDXGIDeviceManager* This,
        HANDLE hDevice);

    HRESULT (STDMETHODCALLTYPE *UnlockDevice)(
        IMFDXGIDeviceManager* This,
        HANDLE hDevice,
        WINBOOL fSaveState);

    END_INTERFACE
} IMFDXGIDeviceManagerVtbl;
interface IMFDXGIDeviceManager {
    CONST_VTBL IMFDXGIDeviceManagerVtbl* lpVtbl;
};

#ifdef COBJMACROS
#ifndef WIDL_C_INLINE_WRAPPERS
/*** IUnknown methods ***/
#define IMFDXGIDeviceManager_QueryInterface(This,riid,ppvObject) (This)->lpVtbl->QueryInterface(This,riid,ppvObject)
#define IMFDXGIDeviceManager_AddRef(This) (This)->lpVtbl->AddRef(This)
#define IMFDXGIDeviceManager_Release(This) (This)->lpVtbl->Release(This)
/*** IMFDXGIDeviceManager methods ***/
#define IMFDXGIDeviceManager_CloseDeviceHandle(This,hDevice) (This)->lpVtbl->CloseDeviceHandle(This,hDevice)
#define IMFDXGIDeviceManager_GetVideoService(This,hDevice,riid,ppService) (This)->lpVtbl->GetVideoService(This,hDevice,riid,ppService)
#define IMFDXGIDeviceManager_LockDevice(This,hDevice,riid,ppUnkDevice,fBlock) (This)->lpVtbl->LockDevice(This,hDevice,riid,ppUnkDevice,fBlock)
#define IMFDXGIDeviceManager_OpenDeviceHandle(This,phDevice) (This)->lpVtbl->OpenDeviceHandle(This,phDevice)
#define IMFDXGIDeviceManager_ResetDevice(This,pUnkDevice,resetToken) (This)->lpVtbl->ResetDevice(This,pUnkDevice,resetToken)
#define IMFDXGIDeviceManager_TestDevice(This,hDevice) (This)->lpVtbl->TestDevice(This,hDevice)
#define IMFDXGIDeviceManager_UnlockDevice(This,hDevice,fSaveState) (This)->lpVtbl->UnlockDevice(This,hDevice,fSaveState)
#else
/*** IUnknown methods ***/
static FORCEINLINE HRESULT IMFDXGIDeviceManager_QueryInterface(IMFDXGIDeviceManager* This,REFIID riid,void **ppvObject) {
    return This->lpVtbl->QueryInterface(This,riid,ppvObject);
}
static FORCEINLINE ULONG IMFDXGIDeviceManager_AddRef(IMFDXGIDeviceManager* This) {
    return This->lpVtbl->AddRef(This);
}
static FORCEINLINE ULONG IMFDXGIDeviceManager_Release(IMFDXGIDeviceManager* This) {
    return This->lpVtbl->Release(This);
}
/*** IMFDXGIDeviceManager methods ***/
static FORCEINLINE HRESULT IMFDXGIDeviceManager_CloseDeviceHandle(IMFDXGIDeviceManager* This,HANDLE hDevice) {
    return This->lpVtbl->CloseDeviceHandle(This,hDevice);
}
static FORCEINLINE HRESULT IMFDXGIDeviceManager_GetVideoService(IMFDXGIDeviceManager* This,HANDLE hDevice,REFIID riid,void **ppService) {
    return This->lpVtbl->GetVideoService(This,hDevice,riid,ppService);
}
static FORCEINLINE HRESULT IMFDXGIDeviceManager_LockDevice(IMFDXGIDeviceManager* This,HANDLE hDevice,REFIID riid,void **ppUnkDevice,WINBOOL fBlock) {
    return This->lpVtbl->LockDevice(This,hDevice,riid,ppUnkDevice,fBlock);
}
static FORCEINLINE HRESULT IMFDXGIDeviceManager_OpenDeviceHandle(IMFDXGIDeviceManager* This,HANDLE *phDevice) {
    return This->lpVtbl->OpenDeviceHandle(This,phDevice);
}
static FORCEINLINE HRESULT IMFDXGIDeviceManager_ResetDevice(IMFDXGIDeviceManager* This,IUnknown *pUnkDevice,UINT resetToken) {
    return This->lpVtbl->ResetDevice(This,pUnkDevice,resetToken);
}
static FORCEINLINE HRESULT IMFDXGIDeviceManager_TestDevice(IMFDXGIDeviceManager* This,HANDLE hDevice) {
    return This->lpVtbl->TestDevice(This,hDevice);
}
static FORCEINLINE HRESULT IMFDXGIDeviceManager_UnlockDevice(IMFDXGIDeviceManager* This,HANDLE hDevice,WINBOOL fSaveState) {
    return This->lpVtbl->UnlockDevice(This,hDevice,fSaveState);
}
#endif
#endif

#endif

HRESULT STDMETHODCALLTYPE IMFDXGIDeviceManager_CloseDeviceHandle_Proxy(
    IMFDXGIDeviceManager* This,
    HANDLE hDevice);
void __RPC_STUB IMFDXGIDeviceManager_CloseDeviceHandle_Stub(
    IRpcStubBuffer* This,
    IRpcChannelBuffer* pRpcChannelBuffer,
    PRPC_MESSAGE pRpcMessage,
    DWORD* pdwStubPhase);
HRESULT STDMETHODCALLTYPE IMFDXGIDeviceManager_GetVideoService_Proxy(
    IMFDXGIDeviceManager* This,
    HANDLE hDevice,
    REFIID riid,
    void **ppService);
void __RPC_STUB IMFDXGIDeviceManager_GetVideoService_Stub(
    IRpcStubBuffer* This,
    IRpcChannelBuffer* pRpcChannelBuffer,
    PRPC_MESSAGE pRpcMessage,
    DWORD* pdwStubPhase);
HRESULT STDMETHODCALLTYPE IMFDXGIDeviceManager_LockDevice_Proxy(
    IMFDXGIDeviceManager* This,
    HANDLE hDevice,
    REFIID riid,
    void **ppUnkDevice,
    WINBOOL fBlock);
void __RPC_STUB IMFDXGIDeviceManager_LockDevice_Stub(
    IRpcStubBuffer* This,
    IRpcChannelBuffer* pRpcChannelBuffer,
    PRPC_MESSAGE pRpcMessage,
    DWORD* pdwStubPhase);
HRESULT STDMETHODCALLTYPE IMFDXGIDeviceManager_OpenDeviceHandle_Proxy(
    IMFDXGIDeviceManager* This,
    HANDLE *phDevice);
void __RPC_STUB IMFDXGIDeviceManager_OpenDeviceHandle_Stub(
    IRpcStubBuffer* This,
    IRpcChannelBuffer* pRpcChannelBuffer,
    PRPC_MESSAGE pRpcMessage,
    DWORD* pdwStubPhase);
HRESULT STDMETHODCALLTYPE IMFDXGIDeviceManager_ResetDevice_Proxy(
    IMFDXGIDeviceManager* This,
    IUnknown *pUnkDevice,
    UINT resetToken);
void __RPC_STUB IMFDXGIDeviceManager_ResetDevice_Stub(
    IRpcStubBuffer* This,
    IRpcChannelBuffer* pRpcChannelBuffer,
    PRPC_MESSAGE pRpcMessage,
    DWORD* pdwStubPhase);
HRESULT STDMETHODCALLTYPE IMFDXGIDeviceManager_TestDevice_Proxy(
    IMFDXGIDeviceManager* This,
    HANDLE hDevice);
void __RPC_STUB IMFDXGIDeviceManager_TestDevice_Stub(
    IRpcStubBuffer* This,
    IRpcChannelBuffer* pRpcChannelBuffer,
    PRPC_MESSAGE pRpcMessage,
    DWORD* pdwStubPhase);
HRESULT STDMETHODCALLTYPE IMFDXGIDeviceManager_UnlockDevice_Proxy(
    IMFDXGIDeviceManager* This,
    HANDLE hDevice,
    WINBOOL fSaveState);
void __RPC_STUB IMFDXGIDeviceManager_UnlockDevice_Stub(
    IRpcStubBuffer* This,
    IRpcChannelBuffer* pRpcChannelBuffer,
    PRPC_MESSAGE pRpcMessage,
    DWORD* pdwStubPhase);

#endif  /* __IMFDXGIDeviceManager_INTERFACE_DEFINED__ */

typedef struct _RTL_CONDITION_VARIABLE {
    PVOID Ptr;
} RTL_CONDITION_VARIABLE, *PRTL_CONDITION_VARIABLE;
#define RTL_CONDITION_VARIABLE_INIT {0}
#define RTL_CONDITION_VARIABLE_LOCKMODE_SHARED  0x1
typedef RTL_CONDITION_VARIABLE CONDITION_VARIABLE, *PCONDITION_VARIABLE;

typedef void (*tyfn_WakeAllConditionVariable)(
  IN OUT PCONDITION_VARIABLE ConditionVariable
);

typedef BOOL (*tyfn_SleepConditionVariableCS)(
  IN OUT PCONDITION_VARIABLE ConditionVariable,
  IN OUT PCRITICAL_SECTION   CriticalSection,
  IN     DWORD               dwMilliseconds
);

void WakeAllConditionVariable(
  IN OUT PCONDITION_VARIABLE ConditionVariable
  ) 
{
	HMODULE hK32 = LoadLibraryA("kernel32.dll");
	
	tyfn_WakeAllConditionVariable pfnWakeAllConditionVariable 
		= (tyfn_WakeAllConditionVariable)GetProcAddress(hK32,"WakeAllConditionVariable");
	
	pfnWakeAllConditionVariable(ConditionVariable);
	
	FreeLibrary(hK32);
}

void SleepConditionVariableCS(
  IN OUT PCONDITION_VARIABLE ConditionVariable,
  IN OUT PCRITICAL_SECTION   CriticalSection,
  IN     DWORD               dwMilliseconds
  ) 
{
	HMODULE hK32 = LoadLibraryA("kernel32.dll");
	
	tyfn_SleepConditionVariableCS pfnSleepConditionVariableCS 
		= (tyfn_SleepConditionVariableCS)GetProcAddress(hK32,"SleepConditionVariableCS");
	
	pfnSleepConditionVariableCS(ConditionVariable,CriticalSection, dwMilliseconds);
	
	FreeLibrary(hK32);
}

struct dxgi_device_manager
{
    IMFDXGIDeviceManager IMFDXGIDeviceManager_iface;
    LONG refcount;
    UINT token;
    IUnknown *device;

    unsigned int *handles;
    size_t count;
    size_t capacity;

    unsigned int locks;
    unsigned int locking_tid;

    CRITICAL_SECTION cs;
    CONDITION_VARIABLE lock;
};
static HRESULT WINAPI dxgi_device_manager_QueryInterface(IMFDXGIDeviceManager *iface, REFIID riid, void **obj)
{
    //TRACE("%p, %s, %p.\n", iface, debugstr_guid(riid), obj);

    if (IsEqualIID(riid, IID_IMFDXGIDeviceManager) ||
        IsEqualGUID(riid, IID_IUnknown))
    {
        *obj = iface;
        IMFDXGIDeviceManager_AddRef(iface);
        return S_OK;
    }

    //WARN("Unsupported %s.\n", debugstr_guid(riid));
    *obj = NULL;
    return E_NOINTERFACE;
}

static struct dxgi_device_manager *impl_from_IMFDXGIDeviceManager(IMFDXGIDeviceManager *iface)
{
    return CONTAINING_RECORD(iface, struct dxgi_device_manager, IMFDXGIDeviceManager_iface);
}
static ULONG WINAPI dxgi_device_manager_AddRef(IMFDXGIDeviceManager *iface)
{
    struct dxgi_device_manager *manager = impl_from_IMFDXGIDeviceManager(iface);
    ULONG refcount = InterlockedIncrement(&manager->refcount);

    //TRACE("%p, refcount %u.\n", iface, refcount);

    return refcount;
}

static ULONG WINAPI dxgi_device_manager_Release(IMFDXGIDeviceManager *iface)
{
    struct dxgi_device_manager *manager = impl_from_IMFDXGIDeviceManager(iface);
    ULONG refcount = InterlockedDecrement(&manager->refcount);

    //TRACE("%p, refcount %u.\n", iface, refcount);

    if (!refcount)
    {
        if (manager->device)
            IUnknown_Release(manager->device);
        DeleteCriticalSection(&manager->cs);
        free(manager->handles);
        free(manager);
    }

    return refcount;
}

enum dxgi_device_handle_flags
{
    DXGI_DEVICE_HANDLE_FLAG_OPEN = 0x1,
    DXGI_DEVICE_HANDLE_FLAG_INVALID = 0x2,
    DXGI_DEVICE_HANDLE_FLAG_LOCKED = 0x4,
};

#define MF_E_DXGI_DEVICE_NOT_INITIALIZED   ((HRESULT)0x80041000)
#define MF_E_DXGI_NEW_VIDEO_DEVICE         ((HRESULT)0x80041001)
#define MF_E_DXGI_VIDEO_DEVICE_LOCKED      ((HRESULT)0x80041002)
static void dxgi_device_manager_unlock_handle(struct dxgi_device_manager *manager, size_t idx)
{
    if (!(manager->handles[idx] & DXGI_DEVICE_HANDLE_FLAG_LOCKED))
        return;

    manager->handles[idx] &= ~DXGI_DEVICE_HANDLE_FLAG_LOCKED;
    if (!--manager->locks)
        manager->locking_tid = 0;
}

static void dxgi_device_manager_lock_handle(struct dxgi_device_manager *manager, size_t idx)
{
    if (manager->handles[idx] & DXGI_DEVICE_HANDLE_FLAG_LOCKED)
        return;

    manager->handles[idx] |= DXGI_DEVICE_HANDLE_FLAG_LOCKED;
    manager->locks++;
}
static HRESULT dxgi_device_manager_get_handle_index(struct dxgi_device_manager *manager, HANDLE hdevice, size_t *idx)
{
    if (!hdevice || hdevice > ULongToHandle(manager->count))
        return E_HANDLE;
    *idx = (ULONG_PTR)hdevice - 1;
    return S_OK;
}

static inline BOOL mf_array_reserve(void **elements, size_t *capacity, size_t count, size_t size)
{
    size_t new_capacity, max_capacity;
    void *new_elements;

    if (count <= *capacity)
        return TRUE;

    max_capacity = ~(SIZE_T)0 / size;
    if (count > max_capacity)
        return FALSE;

    new_capacity = max(4, *capacity);
    while (new_capacity < count && new_capacity <= max_capacity / 2)
        new_capacity *= 2;
    if (new_capacity < count)
        new_capacity = max_capacity;

    if (!(new_elements = realloc(*elements, new_capacity * size)))
        return FALSE;

    *elements = new_elements;
    *capacity = new_capacity;

    return TRUE;
}

static HRESULT WINAPI dxgi_device_manager_OpenDeviceHandle(IMFDXGIDeviceManager *iface, HANDLE *hdevice)
{
    struct dxgi_device_manager *manager = impl_from_IMFDXGIDeviceManager(iface);
    HRESULT hr = S_OK;
    size_t i;

    //TRACE("%p, %p.\n", iface, hdevice);

    *hdevice = NULL;

    EnterCriticalSection(&manager->cs);

    if (!manager->device)
        hr = MF_E_DXGI_DEVICE_NOT_INITIALIZED;
    else
    {
        for (i = 0; i < manager->count; ++i)
        {
            if (!(manager->handles[i] & DXGI_DEVICE_HANDLE_FLAG_OPEN))
            {
                manager->handles[i] |= DXGI_DEVICE_HANDLE_FLAG_OPEN;
                *hdevice = ULongToHandle(i + 1);
                break;
            }
        }

        if (mf_array_reserve((void **)&manager->handles, &manager->capacity, manager->count + 1,
                sizeof(*manager->handles)))
        {
            *hdevice = ULongToHandle(manager->count + 1);
            manager->handles[manager->count++] = DXGI_DEVICE_HANDLE_FLAG_OPEN;
        }
        else
            hr = E_OUTOFMEMORY;
    }

    LeaveCriticalSection(&manager->cs);

    return hr;
}

static __inline const char* wine_dbgstr_guid	(	const GUID * 	id	)	;

static HRESULT WINAPI dxgi_device_manager_ResetDevice(IMFDXGIDeviceManager *iface, IUnknown *device, UINT token)
{
    struct dxgi_device_manager *manager = impl_from_IMFDXGIDeviceManager(iface);
    IUnknown *d3d_device;
    size_t i;

    //TRACE("%p, %p, %u.\n", iface, device, token);

    if (!device || token != manager->token)
        return E_INVALIDARG;

    if (FAILED(IUnknown_QueryInterface(device, IID_ID3D11Device, (void **)&d3d_device)))
    {
        if (FAILED(IUnknown_QueryInterface(device, IID_ID3D12Device, (void **)&d3d_device)))
        {
            //WARN("Unsupported device interface.\n");
            return E_INVALIDARG;
        }
    }

    EnterCriticalSection(&manager->cs);

    if (manager->device)
    {
        for (i = 0; i < manager->count; ++i)
        {
            manager->handles[i] |= DXGI_DEVICE_HANDLE_FLAG_INVALID;
            manager->handles[i] &= ~DXGI_DEVICE_HANDLE_FLAG_LOCKED;
        }
        manager->locking_tid = 0;
        manager->locks = 0;
        IUnknown_Release(manager->device);
    }
    manager->device = d3d_device;

    LeaveCriticalSection(&manager->cs);

    WakeAllConditionVariable(&manager->lock);

    return S_OK;
}

static HRESULT WINAPI dxgi_device_manager_TestDevice(IMFDXGIDeviceManager *iface, HANDLE hdevice)
{
    struct dxgi_device_manager *manager = impl_from_IMFDXGIDeviceManager(iface);
    HRESULT hr;
    size_t idx;

    //TRACE("%p, %p.\n", iface, hdevice);

    EnterCriticalSection(&manager->cs);

    if (SUCCEEDED(hr = dxgi_device_manager_get_handle_index(manager, hdevice, &idx)))
    {
        if (manager->handles[idx] & DXGI_DEVICE_HANDLE_FLAG_INVALID)
            hr = MF_E_DXGI_NEW_VIDEO_DEVICE;
        else if (!(manager->handles[idx] & DXGI_DEVICE_HANDLE_FLAG_OPEN))
            hr = E_HANDLE;
    }

    LeaveCriticalSection(&manager->cs);

    return hr;
}

static HRESULT WINAPI dxgi_device_manager_UnlockDevice(IMFDXGIDeviceManager *iface, HANDLE hdevice,
         BOOL savestate)
{
    struct dxgi_device_manager *manager = impl_from_IMFDXGIDeviceManager(iface);
    HRESULT hr = E_FAIL;
    size_t idx;

    //TRACE("%p, %p, %d.\n", iface, hdevice, savestate);

    EnterCriticalSection(&manager->cs);

    if (SUCCEEDED(dxgi_device_manager_get_handle_index(manager, hdevice, &idx)))
    {
        hr = manager->handles[idx] & DXGI_DEVICE_HANDLE_FLAG_LOCKED ? S_OK : E_INVALIDARG;
        if (SUCCEEDED(hr))
            dxgi_device_manager_unlock_handle(manager, idx);
    }

    LeaveCriticalSection(&manager->cs);

    WakeAllConditionVariable(&manager->lock);

    return hr;
}

static HRESULT WINAPI dxgi_device_manager_LockDevice(IMFDXGIDeviceManager *iface, HANDLE hdevice,
        REFIID riid, void **obj, BOOL block)
{
    struct dxgi_device_manager *manager = impl_from_IMFDXGIDeviceManager(iface);
    HRESULT hr;
    size_t idx;

    //TRACE("%p, %p, %s, %p, %d.\n", iface, hdevice, wine_dbgstr_guid(riid), obj, block);

    EnterCriticalSection(&manager->cs);

    if (SUCCEEDED(hr = dxgi_device_manager_get_handle_index(manager, hdevice, &idx)))
    {
        if (!manager->device)
        {
            hr = MF_E_DXGI_DEVICE_NOT_INITIALIZED;
        }
        else if (manager->locking_tid == GetCurrentThreadId())
        {
            if (SUCCEEDED(hr = IUnknown_QueryInterface(manager->device, riid, obj)))
                dxgi_device_manager_lock_handle(manager, idx);
        }
        else if (manager->locking_tid && !block)
        {
            hr = MF_E_DXGI_VIDEO_DEVICE_LOCKED;
        }
        else
        {
            while (manager->locking_tid)
            {
                SleepConditionVariableCS(&manager->lock, &manager->cs, INFINITE);
            }

            if (SUCCEEDED(hr = dxgi_device_manager_get_handle_index(manager, hdevice, &idx)))
            {
                if (manager->handles[idx] & DXGI_DEVICE_HANDLE_FLAG_INVALID)
                    hr = MF_E_DXGI_NEW_VIDEO_DEVICE;
                else if (SUCCEEDED(hr = IUnknown_QueryInterface(manager->device, riid, obj)))
                {
                    manager->locking_tid = GetCurrentThreadId();
                    dxgi_device_manager_lock_handle(manager, idx);
                }
            }
        }
    }

    LeaveCriticalSection(&manager->cs);

    return hr;
}

static HRESULT WINAPI dxgi_device_manager_GetVideoService(IMFDXGIDeviceManager *iface, HANDLE hdevice,
        REFIID riid, void **service)
{
    struct dxgi_device_manager *manager = impl_from_IMFDXGIDeviceManager(iface);
    HRESULT hr;
    size_t idx;

    //TRACE("%p, %p, %s, %p.\n", iface, hdevice, debugstr_guid(riid), service);

    EnterCriticalSection(&manager->cs);

    if (!manager->device)
        hr = MF_E_DXGI_DEVICE_NOT_INITIALIZED;
    else if (SUCCEEDED(hr = dxgi_device_manager_get_handle_index(manager, hdevice, &idx)))
    {
        if (manager->handles[idx] & DXGI_DEVICE_HANDLE_FLAG_INVALID)
            hr = MF_E_DXGI_NEW_VIDEO_DEVICE;
        else if (manager->handles[idx] & DXGI_DEVICE_HANDLE_FLAG_OPEN)
            hr = IUnknown_QueryInterface(manager->device, riid, service);
        else
            hr = E_HANDLE;
    }

    LeaveCriticalSection(&manager->cs);

    return hr;
}
static HRESULT WINAPI dxgi_device_manager_CloseDeviceHandle(IMFDXGIDeviceManager *iface, HANDLE hdevice)
{
    struct dxgi_device_manager *manager = impl_from_IMFDXGIDeviceManager(iface);
    HRESULT hr;
    size_t idx;

    //TRACE("%p, %p.\n", iface, hdevice);

    EnterCriticalSection(&manager->cs);

    if (SUCCEEDED(hr = dxgi_device_manager_get_handle_index(manager, hdevice, &idx)))
    {
        if (manager->handles[idx] & DXGI_DEVICE_HANDLE_FLAG_OPEN)
        {
            dxgi_device_manager_unlock_handle(manager, idx);
            manager->handles[idx] = 0;
            if (idx == manager->count - 1)
                manager->count--;
        }
        else
            hr = E_HANDLE;
    }

    LeaveCriticalSection(&manager->cs);

    WakeAllConditionVariable(&manager->lock);

    return hr;
}
static  IMFDXGIDeviceManagerVtbl dxgi_device_manager_vtbl =
{
    dxgi_device_manager_QueryInterface,
    dxgi_device_manager_AddRef,
    dxgi_device_manager_Release,
    dxgi_device_manager_CloseDeviceHandle,
    dxgi_device_manager_GetVideoService,
    dxgi_device_manager_LockDevice,
    dxgi_device_manager_OpenDeviceHandle,
    dxgi_device_manager_ResetDevice,
    dxgi_device_manager_TestDevice,
    dxgi_device_manager_UnlockDevice,
};


typedef void (*tyfn_InitializeConditionVariable)(
  OUT PCONDITION_VARIABLE ConditionVariable
);
HRESULT 
WINAPI 
UdxeMFplat_MFCreateDXGIDeviceManager(
	UINT *token, 
	IMFDXGIDeviceManager **manager
	)
{
    struct dxgi_device_manager *object;

    //TRACE("%p, %p.\n", token, manager);

    if (!token || !manager)
        return E_POINTER;

    if (!(object = (dxgi_device_manager*)calloc(1, sizeof(*object))))
        return E_OUTOFMEMORY;

    object->IMFDXGIDeviceManager_iface.lpVtbl = &dxgi_device_manager_vtbl;
    object->refcount = 1;
    object->token = GetTickCount();
    InitializeCriticalSection(&object->cs);
    
	HMODULE hK32 = LoadLibraryA("kernel32.dll");
	tyfn_InitializeConditionVariable pfnInitializeConditionVariable 
		= (tyfn_InitializeConditionVariable)GetProcAddress(hK32, "InitializeConditionVariable");
	pfnInitializeConditionVariable(&object->lock);

	FreeLibrary(hK32);

    //TRACE("Created device manager: %p, token: %u.\n", object, object->token);

    *token = object->token;
    *manager = &object->IMFDXGIDeviceManager_iface;

    return S_OK;
}
